#port0 default MAC：00:11:22:33:44:55
array0=(00 11 22 33 44 55)

shell_version=1.0

function mac_check()
{
	echo $1 |grep -Eq "^([0-9a-f][02468ace])(([:]([0-9a-f]{2})){5})$"
	if [ "$?" != "0" ]; then
		echo "wrong MAC address!"
		exit
	fi
}

function mac_set()
{
	local newarray
	newarray=($(echo "$@"))
	ethtool -E $1 magic 0xd200ffe1 offset 0x0 length 0x1 value 0x15
	ethtool -E $1 magic 0xd200ffe1 offset 0x1 length 0x1 value 0
	ethtool -E $1 magic 0xd200ffe1 offset 0x2 length 0x1 value 0
	ethtool -E $1 magic 0xd200ffe1 offset 0x3 length 0x1 value 0x08

	ethtool -E $1 magic 0xd200ffe1 offset 0x4 length 0x1 value 0x2a
	ethtool -E $1 magic 0xd200ffe1 offset 0x5 length 0x1 value 0
	ethtool -E $1 magic 0xd200ffe1 offset 0x6 length 0x1 value 0
	ethtool -E $1 magic 0xd200ffe1 offset 0x7 length 0x1 value 0

	    # RAL
	ethtool -E $1 magic 0xd200ffe1 offset 0x8 length 0x1 value 0x30
	ethtool -E $1 magic 0xd200ffe1 offset 0x9 length 0x1 value 0
	ethtool -E $1 magic 0xd200ffe1 offset 0xa length 0x1 value 0
	ethtool -E $1 magic 0xd200ffe1 offset 0xb length 0x1 value 0x34

	ethtool -E $1 magic 0xd200ffe1 offset 0xc length 0x1 value 0x${newarray[4]}
	ethtool -E $1 magic 0xd200ffe1 offset 0xd length 0x1 value 0x${newarray[3]}
	ethtool -E $1 magic 0xd200ffe1 offset 0xe length 0x1 value 0x${newarray[2]}
	ethtool -E $1 magic 0xd200ffe1 offset 0xf length 0x1 value 0x${newarray[1]}

	ethtool -E $1 magic 0xd200ffe1 offset 0x10 length 0x1 value 0x30
	ethtool -E $1 magic 0xd200ffe1 offset 0x11 length 0x1 value 0x00
	ethtool -E $1 magic 0xd200ffe1 offset 0x12 length 0x1 value 0x00
	ethtool -E $1 magic 0xd200ffe1 offset 0x13 length 0x1 value 0x30

	ethtool -E $1 magic 0xd200ffe1 offset 0x14 length 0x1 value 0x80
	ethtool -E $1 magic 0xd200ffe1 offset 0x15 length 0x1 value 0x30
	ethtool -E $1 magic 0xd200ffe1 offset 0x16 length 0x1 value 0x8
	ethtool -E $1 magic 0xd200ffe1 offset 0x17 length 0x1 value 0

	    # RAH
	ethtool -E $1 magic 0xd200ffe1 offset 0x18 length 0x1 value 0x30
	ethtool -E $1 magic 0xd200ffe1 offset 0x19 length 0x1 value 0
	ethtool -E $1 magic 0xd200ffe1 offset 0x1a length 0x1 value 0
	ethtool -E $1 magic 0xd200ffe1 offset 0x1b length 0x1 value 0x34

	ethtool -E $1 magic 0xd200ffe1 offset 0x1c length 0x1 value 0x80
	ethtool -E $1 magic 0xd200ffe1 offset 0x1d length 0x1 value 0
	ethtool -E $1 magic 0xd200ffe1 offset 0x1e length 0x1 value 0x${newarray[6]}
	ethtool -E $1 magic 0xd200ffe1 offset 0x1f length 0x1 value 0x${newarray[5]}

	ethtool -E $1 magic 0xd200ffe1 offset 0x20 length 0x1 value 0x30
	ethtool -E $1 magic 0xd200ffe1 offset 0x21 length 0x1 value 0x00
	ethtool -E $1 magic 0xd200ffe1 offset 0x22 length 0x1 value 0x00
	ethtool -E $1 magic 0xd200ffe1 offset 0x23 length 0x1 value 0x30

	ethtool -E $1 magic 0xd200ffe1 offset 0x24 length 0x1 value 0x80
	ethtool -E $1 magic 0xd200ffe1 offset 0x25 length 0x1 value 0x30
	ethtool -E $1 magic 0xd200ffe1 offset 0x26 length 0x1 value 0x8
	ethtool -E $1 magic 0xd200ffe1 offset 0x27 length 0x1 value 0x4

	ethtool -E $1 magic 0xd200ffe1 offset 0x28 length 0x1 value 0xf0
	ethtool -E $1 magic 0xd200ffe1 offset 0x29 length 0x1 value 0
	ethtool -E $1 magic 0xd200ffe1 offset 0x2a length 0x1 value 0
	ethtool -E $1 magic 0xd200ffe1 offset 0x2b length 0x1 value 0


	for ((i=44; i<=235; i++))
	do
		ethtool -E $1 magic 0xd200ffe1 offset $i length 0x1 value 0xff
	done
	ethtool -e $1

}

if [ -z $1 ]; then
	echo "./eeprom_82101.sh [interface] "
	echo "residual parameters:"
	echo "     -mac [mac]       Modify the MAC address of the port "
	echo "     -h               Show help"
	echo "     -v               Show version"
	echo "     *Input interface as: enp1s0f0"
	echo "     *Input port as: 0/1"
	echo "     *Input mac address as: xx:xx:xx:xx:xx:xx"
elif [[ $# -eq 2 ]]; then
	if [ $2 == "-h" ]; then
		echo "./eeprom_82101.sh [interface] "
		echo "residual parameters:"
		echo "     -mac [mac]       Modify the MAC address of the port "
		echo "     -h               Show help"
		echo "     -v               Show version"
		echo "     *Input interface as: enp1s0f0"
		echo "     *Input port as: 0/1"
		echo "     *Input mac address as: xx:xx:xx:xx:xx:xx"
	elif [ $2 == "-v" ]; then
		echo "version: $shell_version"
	else
		echo "Input parameter error !"
		exit
	fi
elif [[ $# -eq 3 ]]; then
	if [ $2 == "-mac" ]; then
		echo "Reset the MAC address of port0 ..."
	    mac_check $3
	    array0=(${3//:/ })
		mac_set $1 ${array0[*]}
	else
		echo "Input parameter error !"
		exit
	fi

else
	echo "Input parameter error !"
	exit
fi
